<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.7 $
 * $Author: tora60 $
 * $Date: 2014-04-04 12:42:09 $
 */

defined('mxMainFileLoaded') or die('access denied');

/* initialisiert die Variable zum Zaehlen der SQL-Abfragen */
/* TODO: deprecated */
$GLOBALS['mxQueryCount'] = 0;

/* Datenbanktyp explizit auf MySql stellen */
$GLOBALS['dbtype'] = "MySQL";

/**
 * sobald die config.php geschrieben ist, wird diese Verbindung verwendet
 */
function setupConnectDb($dbhost = '', $dbuname = '', $dbpass = '', $dbname = '')
{
    $out['msg'] = '';
    if (empty($dbhost) && empty($dbuname) && empty($dbpass) && empty($dbname)) {
        @ini_set('track_errors', '1');
        if (!@include(FILE_CONFIG_ROOT)) {
            $out['msg'] = '
              <div class="alert alert-error alert-block">
                <p>' . _THEREERROR . ':</p>
                <p>' . _SERVERMESSAGE . ': ' . @$php_errormsg . '</p>
              </div>';
            return $out;
        }
    }
    $dbi = @mysql_connect($dbhost, $dbuname, $dbpass);
    $GLOBALS['dbi'] = $dbi;
    if (!$dbi) {
        $out['msg'] .= '
          <p><strong>' . _NOT_CONNECT . '</strong></p><p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')</p>';
        define('MX_SQL_VERSION', 0);
    } else {
        /* Probleme mit evtl. falschem Charset beheben */
        setup_set_sql_names('utf8');

        if (!defined('MX_SQL_VERSION')) {
            list($mysqlversion) = sql_fetch_row(sql_query("SELECT VERSION() as version"));
            define('MX_SQL_VERSION', $mysqlversion);
        }
        if (version_compare(MX_SQL_VERSION, MX_SETUP_MIN_MYSQLVERSION, '<')) {
            $out['msg'] .= '<div class="alert alert-error alert-block">' . sprintf(_DBVERSIONFALSE, MX_SETUP_MIN_MYSQLVERSION) . '</div>' . str_repeat('<br />', 50);
        } else if (!mysql_select_db($dbname , $dbi)) {
            $out['msg'] .= '<p>' . _DBNOTEXIST . '</p>
              <p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')</p>';
            // $out['dbnotexist'] = TRUE;
        } else {
            $out['dbi'] = $dbi;
            $out['msg'] .= sprintf(_DB_CONNECTSUCCESS, $dbname);
        }
    }

    return $out;
}

/**
 * checkt ob eine Tabelle vorhanden ist,
 * mit dem 2ten Parameter kann das Tabellenarray aktualisiert werden
 */
function setupTableExist($tablename, $refr_array = 0)
{
    global $tables;
    if (empty($tablename)) {
        return false;
    }
    $result = sql_query("SHOW TABLES LIKE '${tablename}';");
    $is = mysql_num_rows($result);
    if ($is) {
        if ($refr_array) {
            $tables[$tablename] = $tablename;
        }
        return true;
    } else {
        if ($refr_array) {
            unset($tables[$tablename]);
        }
        return false;
    }
}

/**
 * liest alle Felder einer Tabelle in ein assoziatives Array
 * der Feldname dient als Index
 */
function setupGetTableFields($tablename)
{
    global $tables;
    // print "<h5>$tablename</h5>";
    $fields = array();
    $result = sql_query("DESCRIBE `${tablename}`");
    if (!$result || mysql_error()) {
        // irgenwie kommt das ab und an zu dem Fehler:
        // - Can't create/write to file '/tmp/#sql_8c4_0.MYD' (Errcode: 13)
        // http://bugs.mysql.com/bug.php?id=25872
        // dann einfach etwas warten und nochmal probieren ;-))
        sleep(1);
        $result = sql_query("DESCRIBE `${tablename}`");
    } while ($row = sql_fetch_array($result, MYSQL_ASSOC)) {
        $fields[$row['Field']] = $row;
    }
    sql_free_result($result);
    return $fields;
}

/**
 * liest alle indexe einer Tabelle in ein Array
 */
function setupGetTableIndexes($tablename)
{
    $indexes = array();
    $result = sql_query("SHOW INDEXES FROM `${tablename}`");
    if (!$result || mysql_error()) {
        // siehe dazu: setupGetTableFields()
        sleep(1);
        $result = sql_query("SHOW INDEXES FROM `${tablename}`");
    } while ($row = sql_fetch_array($result, MYSQL_ASSOC)) {
        if (!isset($indexes[$row['Key_name']])) {
            $indexes[$row['Key_name']] = $row;
        }
        $indexes[$row['Key_name']]['all_fields'][$row['Column_name']] = $row['Seq_in_index'];
    }
    sql_free_result($result);
    return $indexes;
}

/**
 * sql_connect()
 * Datenbankverbindung herstellen
 * Datenbank auswaehlen
 *
 * @return
 */
function sql_connect($host, $user, $password)
{
    global $dbi;
    // wenn bereits Datenbankverbindung besteht....
    if (!is_resource($dbi)) {
        $dbi = @mysql_connect($host, $user, $password);
    }
    sql_select_db($dbi);
    return $dbi;
}

/**
 * sql_select_db()
 * Datenbank auswaehlen
 *
 * @param mixed $dbi
 * @return
 */
function sql_select_db($dbi)
{
    if (empty($dbi)) {
        if (mysql_errno() == 1045) {
            $msg = ("Die Benutzerdaten zur Datenbank sind falsch angegeben!<br />The user data to the database are given wrong!");
        } else if (mysql_errno() == 2005) {
            $msg = ("Der Datenbank-Host ist falsch angegeben!<br />The database host is set incorrectly!");
        } else {
            $msg = mysql_error();
        }
    }
    if (!isset($msg)) {
        $isdb = mysql_select_db(@$GLOBALS['dbname'], $dbi);
        if (!$isdb) {
            if (mysql_errno() == 1049) {
                $msg = ("Der Datenbank-Name ist falsch angegeben!<br />The database name is set incorrectly!");
            } else {
                $msg = mysql_error();
            }
        }
    }
    if (isset($msg)) {
        if (!defined('MX_SQL_VERSION')) {
            define('MX_SQL_VERSION', '0');
        }

        /* Fehlerbehandlung */
        // if (mysql_error()) {
        // sql_trigger_error();
        // }
        $msg = "Sorry, wir haben zur Zeit Probleme mit der Datenbank.<br/>Sorry, we have some database-problems.<br/><br/>(" . mysql_errno() . ")";
        die(mxSqlPrepareMessage('<html><head><title>' . $GLOBALS['sitename'] . '</title></head><body text="#000080"><h1>' . $GLOBALS['sitename'] . '</h1>' . $msg . '<br/><br/><br/>pragmaMx ' . PMX_VERSION . '</body></html>'));
    }
    if (!defined('MX_SQL_VERSION')) {
        list($mysqlversion) = sql_fetch_row(sql_query("SELECT VERSION() as version"));
        define('MX_SQL_VERSION', $mysqlversion);
    }

    /* Probleme mit evtl. falschem Charset beheben */
    sql_query("SET
      names 'utf8',
      character set 'utf8',
      character_set_results = 'utf8',
      character_set_client = 'utf8',
      character_set_connection = 'utf8',
      character_set_database = 'utf8',
      character_set_server = 'utf8'
    ");

    /* Zeitzone einstellen */
    sql_query("SET time_zone = '" . date('P') . "';");

    /* Datenbank-Handle zurueckgeben */
    return $dbi;
}

/**
 * sql_close()
 * Schließt die Verbindung zu MySQL
 *
 * @return
 */
function sql_close($dbid = null)
{
    return mysql_close();
}

/**
 * sql_logout()
 * Schließt die Verbindung zu MySQL (alias von close)
 *
 * @return
 */
function sql_logout($dbid = null)
{
    return mysql_close();
}

/**
 * sql_insert_id()
 * Liefert die ID einer vorherigen INSERT-Operation
 *
 * @return
 */
function sql_insert_id($dbid = null)
{
    if (is_null($dbid)) {
        return mysql_insert_id();
    }
    return mysql_insert_id($dbid);
}

/**
 * sql_affected_rows()
 * liefert die Anzahl betroffener Datensaetze durch die letzte INSERT, UPDATE oder DELETE Anfrage
 * an den Server, die mit der angegebenen Verbindungs-Kennung assoziiert wird.
 * Wird die Verbindungskennung nicht angegeben, wird die letzte durch mysql_connect() geoeffnete Verbindung angenommen
 *
 * @return
 */
function sql_affected_rows($dbid = null)
{
    if (is_null($dbid)) {
        return mysql_affected_rows();
    }
    return intval(mysql_affected_rows($dbid));
}

/**
 * sql_query()
 * executes an SQL statement, returns a result identifier
 *
 * @param mixed $query
 * @return
 */
function sql_query($query, $dbid = null)
{
    // static $i = 0;
    // $i++;
    /* die DB-Anfrage ausführen */
    if (is_null($dbid)) {
        $result = mysql_query($query);
    } else {
        $result = mysql_query($query, $dbid);
    }
    // $msg = $i . ' --> ' . preg_replace('#\s+#', ' ', $query) . PHP_EOL;
    // error_log($msg, 3, FILE_LOG_QUERIES);
    /* Fehlerbehandlung */
    if (mysql_error()) {
        return false;
    }

    return $result;
}
/**
 * sql_system_query()
 * executes an SQL statement, returns a result identifier
 *
 * @param mixed $query
 * @return
 */
function sql_system_query($query, $dbid = null)
{
    return sql_query($query, $dbid);
}

/**
 * sql_num_rows()
 * given a result identifier, returns the number of affected rows
 *
 * @param mixed $result
 * @return
 */
function sql_num_rows($result)
{
    if (!is_resource($result)) {
        return 0;
    }
    return intval(mysql_num_rows($result));
}

/**
 * sql_fetch_row()
 * given a result identifier, returns an array with the resulting row
 *
 * @param mixed $result
 * @return
 */
function sql_fetch_row($result)
{
    if (!is_resource($result)) {
        return false;
    }
    return mysql_fetch_row($result);
}

/**
 * sql_fetch_array()
 * given a result identifier, returns an associative and numeric array
 * with the resulting row using field names as keys.
 *
 * @param mixed $result
 * @return
 */
function sql_fetch_array($result)
{
    if (!is_resource($result)) {
        return false;
    }
    return mysql_fetch_array($result);
}

/**
 * sql_fetch_assoc()
 * given a result identifier, returns an associative array
 * with the resulting row using field names as keys.
 *
 * @param mixed $result
 * @return
 */
function sql_fetch_assoc($result)
{
    if (!is_resource($result)) {
        return false;
    }
    return mysql_fetch_array($result, MYSQL_ASSOC);
}

/**
 * sql_fetch_object()
 * given a result identifier, returns an object
 *
 * @param mixed $result
 * @return
 */
function sql_fetch_object($result)
{
    if (!is_resource($result)) {
        return false;
    }
    return mysql_fetch_object($result);
}

/**
 * sql_fetch_rowset()
 * Fetch all rows in an array
 *
 * @param mixed $result
 * @return
 */
function sql_fetch_rowset($result)
{
    if (!is_resource($result)) {
        return false;
    }
    $rowset = array();
    while ($row = sql_fetch_array($result, MYSQL_ASSOC)) {
        $rowset[] = $row;
    }
    return $rowset;
}

/**
 * sql_free_result()
 * for function free the memory
 *
 * @param mixed $result
 * @return
 */
function sql_free_result($result)
{
    if (!is_resource($result)) {
        return false;
    }
    return mysql_free_result($result);
}

/**
 * sql_error()
 *
 * @return
 */
function sql_error()
{
    return mysql_error();
}

/**
 * sql_errno()
 *
 * @return
 */
function sql_errno ()
{
    return mysql_errno();
}

/**
 * mxSqlPrepareMessage()
 * u.A. die Datenbankverbindungsdaten aus den Fehlermeldungen entfernen
 *
 * @param mixed $msg
 * @param string $class
 * @return
 */
function mxSqlPrepareMessage($msg, $class = '')
{
    return $msg;
}

/**
 * sql_trigger_error()
 *
 * @param mixed $query
 * @return
 */
function sql_trigger_error($query = false)
{
    // pmxDebug::sql_trigger_error($GLOBALS['dbtype'], __FILE__, mysql_error(), mysql_errno(), $query);
}

?>
